import{s as Me,n as xe,o as ye}from"../chunks/scheduler.37c15a92.js";import{S as He,i as Re,g as r,s as a,r as k,A as ke,h as s,f as i,c as l,j as _e,u as A,x as o,k as Ce,y as Ae,a as n,v as P,d as E,t as q,w as D}from"../chunks/index.7cb9c9b8.js";import{H as F,E as Pe}from"../chunks/EditOnGithub.858acfec.js";function Ee(oe){let u,O,I,U,m,j,f,ue="While most of the RL methods seen in this course work well in practice, there are some cases where using them alone fails. This can happen, for instance, when:",S,p,me="<li>the task to learn is hard and requires an <strong>incremental acquisition of skills</strong> (for instance when one wants to make a bipedal agent learn to go through hard obstacles, it must first learn to stand, then walk, then maybe jump…)</li> <li>there are variations in the environment (that affect the difficulty) and one wants its agent to be <strong>robust</strong> to them</li>",G,c,fe='<img src="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit9/bipedal.gif" alt="Bipedal"/> <img src="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit9/movable_creepers.gif" alt="Movable creepers"/> <figcaption><a href="https://developmentalsystems.org/TeachMyAgent/">TeachMyAgent</a></figcaption>',B,h,pe="In such cases, it seems needed to propose different tasks to our RL agent and organize them such that the agent progressively acquires skills. This approach is called <strong>Curriculum Learning</strong> and usually implies a hand-designed curriculum (or set of tasks organized in a specific order). In practice, one can, for instance, control the generation of the environment, the initial states, or use Self-Play and control the level of opponents proposed to the RL agent.",K,g,ce="As designing such a curriculum is not always trivial, the field of <strong>Automatic Curriculum Learning (ACL) proposes to design approaches that learn to create such an organization of tasks in order to maximize the RL agent’s performances</strong>. Portelas et al. proposed to define ACL as:",Q,d,he="<p>… a family of mechanisms that automatically adapt the distribution of training data by learning to adjust the selection of learning situations to the capabilities of RL agents.</p>",W,v,ge="As an example, OpenAI used <strong>Domain Randomization</strong> (they applied random variations on the environment) to make a robot hand solve Rubik’s Cubes.",J,L,de='<img src="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit9/dr.jpg" alt="Dr"/> <figcaption><a href="https://openai.com/blog/solving-rubiks-cube/">OpenAI - Solving Rubik’s Cube with a Robot Hand</a></figcaption>',N,$,ve='Finally, you can play with the robustness of agents trained in the <a href="https://huggingface.co/spaces/flowers-team/Interactive_DeepRL_Demo">TeachMyAgent</a> benchmark by controlling environment variations or even drawing the terrain 👇',V,w,Le='<img src="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit9/demo.png" alt="Demo"/> <figcaption><a href="https://huggingface.co/spaces/flowers-team/Interactive_DeepRL_Demo">https://huggingface.co/spaces/flowers-team/Interactive_DeepRL_Demo</a></figcaption>',X,b,Y,T,$e="For more information, we recommend that you check out the following resources:",Z,_,ee,C,we='<li><a href="https://arxiv.org/pdf/2003.04664.pdf" rel="nofollow">Automatic Curriculum Learning For Deep RL: A Short Survey</a></li> <li><a href="https://lilianweng.github.io/posts/2020-01-29-curriculum-rl/" rel="nofollow">Curriculum for Reinforcement Learning</a></li>',te,M,ie,x,be='<li><a href="https://arxiv.org/abs/2203.01302" rel="nofollow">Evolving Curricula with Regret-Based Environment Design</a></li> <li><a href="https://proceedings.mlr.press/v162/klink22a.html" rel="nofollow">Curriculum Reinforcement Learning via Constrained Optimal Transport</a></li> <li><a href="https://arxiv.org/abs/2010.03934" rel="nofollow">Prioritized Level Replay</a></li>',ne,y,ae,H,Te='This section was written by <a href="https://twitter.com/ClementRomac">Clément Romac</a>',le,R,re,z,se;return m=new F({props:{title:"(Automatic) Curriculum Learning for RL",local:"automatic-curriculum-learning-for-rl",headingTag:"h1"}}),b=new F({props:{title:"Further reading",local:"further-reading",headingTag:"h2"}}),_=new F({props:{title:"Overview of the field",local:"overview-of-the-field",headingTag:"h3"}}),M=new F({props:{title:"Recent methods",local:"recent-methods",headingTag:"h3"}}),y=new F({props:{title:"Author",local:"author",headingTag:"h2"}}),R=new Pe({props:{source:"https://github.com/huggingface/deep-rl-class/blob/main/units/en/unitbonus3/curriculum-learning.mdx"}}),{c(){u=r("meta"),O=a(),I=r("p"),U=a(),k(m.$$.fragment),j=a(),f=r("p"),f.textContent=ue,S=a(),p=r("ul"),p.innerHTML=me,G=a(),c=r("figure"),c.innerHTML=fe,B=a(),h=r("p"),h.innerHTML=pe,K=a(),g=r("p"),g.innerHTML=ce,Q=a(),d=r("blockquote"),d.innerHTML=he,W=a(),v=r("p"),v.innerHTML=ge,J=a(),L=r("figure"),L.innerHTML=de,N=a(),$=r("p"),$.innerHTML=ve,V=a(),w=r("figure"),w.innerHTML=Le,X=a(),k(b.$$.fragment),Y=a(),T=r("p"),T.textContent=$e,Z=a(),k(_.$$.fragment),ee=a(),C=r("ul"),C.innerHTML=we,te=a(),k(M.$$.fragment),ie=a(),x=r("ul"),x.innerHTML=be,ne=a(),k(y.$$.fragment),ae=a(),H=r("p"),H.innerHTML=Te,le=a(),k(R.$$.fragment),re=a(),z=r("p"),this.h()},l(e){const t=ke("svelte-u9bgzb",document.head);u=s(t,"META",{name:!0,content:!0}),t.forEach(i),O=l(e),I=s(e,"P",{}),_e(I).forEach(i),U=l(e),A(m.$$.fragment,e),j=l(e),f=s(e,"P",{"data-svelte-h":!0}),o(f)!=="svelte-divgy0"&&(f.textContent=ue),S=l(e),p=s(e,"UL",{"data-svelte-h":!0}),o(p)!=="svelte-1fijmic"&&(p.innerHTML=me),G=l(e),c=s(e,"FIGURE",{"data-svelte-h":!0}),o(c)!=="svelte-259cr2"&&(c.innerHTML=fe),B=l(e),h=s(e,"P",{"data-svelte-h":!0}),o(h)!=="svelte-16unqvo"&&(h.innerHTML=pe),K=l(e),g=s(e,"P",{"data-svelte-h":!0}),o(g)!=="svelte-t9kiqj"&&(g.innerHTML=ce),Q=l(e),d=s(e,"BLOCKQUOTE",{"data-svelte-h":!0}),o(d)!=="svelte-1i9zwqs"&&(d.innerHTML=he),W=l(e),v=s(e,"P",{"data-svelte-h":!0}),o(v)!=="svelte-q06j09"&&(v.innerHTML=ge),J=l(e),L=s(e,"FIGURE",{"data-svelte-h":!0}),o(L)!=="svelte-habslb"&&(L.innerHTML=de),N=l(e),$=s(e,"P",{"data-svelte-h":!0}),o($)!=="svelte-4l6fnl"&&($.innerHTML=ve),V=l(e),w=s(e,"FIGURE",{"data-svelte-h":!0}),o(w)!=="svelte-15rau72"&&(w.innerHTML=Le),X=l(e),A(b.$$.fragment,e),Y=l(e),T=s(e,"P",{"data-svelte-h":!0}),o(T)!=="svelte-144wssd"&&(T.textContent=$e),Z=l(e),A(_.$$.fragment,e),ee=l(e),C=s(e,"UL",{"data-svelte-h":!0}),o(C)!=="svelte-19o2s58"&&(C.innerHTML=we),te=l(e),A(M.$$.fragment,e),ie=l(e),x=s(e,"UL",{"data-svelte-h":!0}),o(x)!=="svelte-1cnmd2q"&&(x.innerHTML=be),ne=l(e),A(y.$$.fragment,e),ae=l(e),H=s(e,"P",{"data-svelte-h":!0}),o(H)!=="svelte-a8x2u9"&&(H.innerHTML=Te),le=l(e),A(R.$$.fragment,e),re=l(e),z=s(e,"P",{}),_e(z).forEach(i),this.h()},h(){Ce(u,"name","hf:doc:metadata"),Ce(u,"content",qe)},m(e,t){Ae(document.head,u),n(e,O,t),n(e,I,t),n(e,U,t),P(m,e,t),n(e,j,t),n(e,f,t),n(e,S,t),n(e,p,t),n(e,G,t),n(e,c,t),n(e,B,t),n(e,h,t),n(e,K,t),n(e,g,t),n(e,Q,t),n(e,d,t),n(e,W,t),n(e,v,t),n(e,J,t),n(e,L,t),n(e,N,t),n(e,$,t),n(e,V,t),n(e,w,t),n(e,X,t),P(b,e,t),n(e,Y,t),n(e,T,t),n(e,Z,t),P(_,e,t),n(e,ee,t),n(e,C,t),n(e,te,t),P(M,e,t),n(e,ie,t),n(e,x,t),n(e,ne,t),P(y,e,t),n(e,ae,t),n(e,H,t),n(e,le,t),P(R,e,t),n(e,re,t),n(e,z,t),se=!0},p:xe,i(e){se||(E(m.$$.fragment,e),E(b.$$.fragment,e),E(_.$$.fragment,e),E(M.$$.fragment,e),E(y.$$.fragment,e),E(R.$$.fragment,e),se=!0)},o(e){q(m.$$.fragment,e),q(b.$$.fragment,e),q(_.$$.fragment,e),q(M.$$.fragment,e),q(y.$$.fragment,e),q(R.$$.fragment,e),se=!1},d(e){e&&(i(O),i(I),i(U),i(j),i(f),i(S),i(p),i(G),i(c),i(B),i(h),i(K),i(g),i(Q),i(d),i(W),i(v),i(J),i(L),i(N),i($),i(V),i(w),i(X),i(Y),i(T),i(Z),i(ee),i(C),i(te),i(ie),i(x),i(ne),i(ae),i(H),i(le),i(re),i(z)),i(u),D(m,e),D(b,e),D(_,e),D(M,e),D(y,e),D(R,e)}}}const qe='{"title":"(Automatic) Curriculum Learning for RL","local":"automatic-curriculum-learning-for-rl","sections":[{"title":"Further reading","local":"further-reading","sections":[{"title":"Overview of the field","local":"overview-of-the-field","sections":[],"depth":3},{"title":"Recent methods","local":"recent-methods","sections":[],"depth":3}],"depth":2},{"title":"Author","local":"author","sections":[],"depth":2}],"depth":1}';function De(oe){return ye(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class Oe extends He{constructor(u){super(),Re(this,u,De,Ee,Me,{})}}export{Oe as component};
